Unit Wnaspi32;
interface
{/****************************************************************************
*                                                                           *
* THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY     *
* KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE       *
* IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR     *
* PURPOSE.                                                                  *
*                                                                           *
* Copyright (C) 1993-95  Microsoft Corporation.  All Rights Reserved.       *
*                                                                           *
****************************************************************************/

//***************************************************************************
//
// Name: 	      WNASPI32.h
//
// Description:	ASPI for Win32 definitions
//
//
//***************************************************************************
// Recycled for Delphi.
// needs installed wnaspi32.dll, whitch is included in Win95
// and freely available for NT
//
//
// Febr. 1998
}
type DWORD=Cardinal;

type LPSRB=Pointer;
type PFNPOST=Pointer;

function SendASPI32Command(P:LPSRB):DWORD; stdcall; external 'wnaspi32.dll';
function GetASPI32SupportInfo:DWORD; stdcall; external 'wnaspi32.dll';



const
 SENSE_LEN=14;			       // Default sense buffer length
 SRB_DIR_SCSI=$00;		       // Direction determined by SCSI 															// command
 SRB_DIR_IN=$08;	               // Transfer from SCSI target to 															// host
 SRB_DIR_OUT=$10;	               // Transfer from host to SCSI 															// target
 SRB_POSTING=$01;	               // Enable ASPI posting
 SRB_EVENT_NOTIFY=$40;                 // Enable ASPI event notification
 SRB_ENABLE_RESIDUAL_COUNT=$04;        // Enable residual byte count 															// reporting
 SRB_DATA_SG_LIST=$02;	               // Data buffer points to 																	// scatter-gather list
 WM_ASPIPOST=$4D42;	               // ASPI Post message
//***************************************************************************
//						 %%% ASPI Command Definitions %%%
//***************************************************************************
 SC_HA_INQUIRY=$00;	               // Host adapter inquiry
 SC_GET_DEV_TYPE=$01;                  // Get device type
 SC_EXEC_SCSI_CMD=$02;	               // Execute SCSI command
 SC_ABORT_SRB=$03;	               // Abort an SRB
 SC_RESET_DEV=$04;	               // SCSI bus device reset
 SC_GET_DISK_INFO=$06;	               // Get Disk information

//***************************************************************************
//								  %%% SRB Status %%%
//***************************************************************************
 SS_PENDING=$00;		       // SRB being processed
 SS_COMP=$01;		               // SRB completed without error
 SS_ABORTED=$02;		       // SRB aborted
 SS_ABORT_FAIL=$03;	               // Unable to abort SRB
 SS_ERR=$04;		               // SRB completed with error

 SS_INVALID_CMD=$80;	               // Invalid ASPI command
 SS_INVALID_HA=$81;	               // Invalid host adapter number
 SS_NO_DEVICE=$82;	               // SCSI device not installed

 SS_INVALID_SRB=$E0;	               // Invalid parameter set in SRB
 SS_FAILED_INIT=$E4;	               // ASPI for windows failed init
 SS_ASPI_IS_BUSY=$E5;	               // No resources available to execute cmd
 SS_BUFFER_TO_BIG=$E6;	               // Buffer size to big to handle!

//***************************************************************************
//							%%% Host Adapter Status %%%
//***************************************************************************
 HASTAT_OK=$00;	                       // Host adapter did not detect an 															// error
 HASTAT_SEL_TO=$11;	               // Selection Timeout
 HASTAT_DO_DU=$12;	               // Data overrun data underrun
 HASTAT_BUS_FREE=$13;                  // Unexpected bus free
 HASTAT_PHASE_ERR=$14;	               // Target bus phase sequence 																// failure
 HASTAT_TIMEOUT=$09;	               // Timed out while SRB was waiting to beprocessed.
 HASTAT_COMMAND_TIMEOUT=$0B;           // While processing the SRB, the
				       // adapter timed out.
 HASTAT_MESSAGE_REJECT=$0D;            // While processing SRB, the 																// adapter received a MESSAGE 															// REJECT.
 HASTAT_BUS_RESET=$0E;	               // A bus reset was detected.
 HASTAT_PARITY_ERROR=$0F;              // A parity error was detected.
 HASTAT_REQUEST_SENSE_FAILED=$10;      // The adapter failed in issuing
				       //   REQUEST SENSE.

//***************************************************************************
//			 %%% SRB - HOST ADAPTER INQUIRY - SC_HA_INQUIRY %%%
//***************************************************************************
type  PSRB_HAInquiry=^SRB_HAInquiry;
      SRB_HAInquiry=record
	SRB_Cmd:Byte;	               // ASPI command code = SC_HA_INQUIRY
	SRB_Status:Byte;	       // ASPI command status byte
	SRB_HaId:Byte;	               // ASPI host adapter number
	SRB_Flags:Byte;	               // ASPI request flags
	SRB_Hdr_Rsvd:DWORD;	       // Reserved, MUST = 0
	HA_Count:Byte;	               // Number of host adapters present
	HA_SCSI_ID:Byte;	       // SCSI ID of host adapter
	HA_ManagerId:array [0..15] of Byte;   // String describing the manager
	HA_Identifier:array[0..15] of Byte;   // String describing the host adapter
	HA_Unique:array[0..15] of Byte;	      // Host Adapter Unique parameters
	HA_Rsvd1:Word;
     end;

//***************************************************************************
//			  %%% SRB - GET DEVICE TYPE - SC_GET_DEV_TYPE %%%
//***************************************************************************
type PSRB_GDEVBlock=^SRB_GDEVBlock;
     SRB_GDEVBlock=Record
	SRB_Cmd:Byte;	               // ASPI command code = SC_GET_DEV_TYPE
	SRB_Status:Byte;	       // ASPI command status byte
	SRB_HaId:Byte;	               // ASPI host adapter number
	SRB_Flags:Byte;	               // Reserved
	SRB_Hdr_Rsvd:DWORD;	       // Reserved
	SRB_Target:Byte;	       // Target's SCSI ID
	SRB_Lun:Byte;	               // Target's LUN number
	SRB_DeviceType:Byte;	       // Target's peripheral device type
	SRB_Rsvd1:Byte;
     end;

//***************************************************************************
//		  %%% SRB - EXECUTE SCSI COMMAND - SC_EXEC_SCSI_CMD %%%
//***************************************************************************

type PSRB_ExecSCSICmd=^SRB_ExecSCSICmd;
     SRB_ExecSCSICmd=record
	SRB_Cmd:Byte;		       // ASPI command code = SC_EXEC_SCSI_CMD
	SRB_Status:Byte;	       // ASPI command status byte
	SRB_HaId:Byte;		       // ASPI host adapter number
	SRB_Flags:Byte;		       // ASPI request flags
	SRB_Hdr_Rsvd:DWORD;	       // Reserved
	SRB_Target:Byte;	       // Target's SCSI ID
	SRB_Lun:Byte;		       // Target's LUN number
	SRB_Rsvd1:Word;		       // Reserved for Alignment
	SRB_BufLen:DWORD;	       // Data Allocation Length
	SRB_BufPointer:Pointer;        // Data Buffer Pointer
	SRB_SenseLen:Byte;	       // Sense Allocation Length
	SRB_CDBLen:Byte;	       // CDB Length
	SRB_HaStat:Byte;	       // Host Adapter Status
	SRB_TargStat:Byte;	       // Target Status
	SRB_PostProc:POINTER;	       // Post routine
	SRB_Rsvd2:POINTER;	       // Reserved
	SRB_Rsvd3:Array [0..15] of Byte;// Reserved for alignment
	CDBByte:Array [0..15] of Byte; // SCSI CDB
	SenseArea:Array [0..SENSE_LEN+1] of Byte;// Request Sense buffer
  end;

//***************************************************************************
//				  %%% SRB - ABORT AN SRB - SC_ABORT_SRB %%%
//***************************************************************************
type pSRB_Abort=^SRB_Abort;
     SRB_Abort=record
	SRB_Cmd:Byte;		       // ASPI command code = SC_EXEC_SCSI_CMD
	SRB_Status:Byte;	       // ASPI command status byte
	SRB_HaId:Byte;		       // ASPI host adapter number
	SRB_Flags:Byte;		       // Reserved
	SRB_Hdr_Rsvd:DWORD;	       // Reserved
	SRB_ToAbort:Pointer;	       // Pointer to SRB to abort
  end;

//***************************************************************************
//				%%% SRB - BUS DEVICE RESET - SC_RESET_DEV %%%
//***************************************************************************
type pSRB_BusDeviceReset=^SRB_BusDeviceReset;
     SRB_BusDeviceReset=record
	SRB_Cmd:Byte;                  // ASPI command code = SC_EXEC_SCSI_CMD
	SRB_Status:Byte;	       // ASPI command status byte
	SRB_HaId:Byte;		       // ASPI host adapter number
	SRB_Flags:Byte;		       // Reserved
	SRB_Hdr_Rsvd:DWORD;	       // Reserved
	SRB_Target:Byte;	       // Target's SCSI ID
	SRB_Lun:Byte;		       // Target's LUN number
	SRB_Rsvd1:array [0..11] of Byte;// Reserved for Alignment
	SRB_HaStat:Byte; 	       // Host Adapter Status
	SRB_TargStat:Byte;	       // Target Status
	SRB_PostProc:Pointer;	       // Post routine
	SRB_Rsvd2:Pointer;	       // Reserved
	SRB_Rsvd3:array[0..15] of Byte;// Reserved
	CDBByte:array[0..15] of Byte;  // SCSI CDB  end;
   end;

//***************************************************************************
//		%%% SRB - GET DISK INFORMATION - SC_GET_DISK_INFO %%%
//***************************************************************************
type PSRB_GetDiskInfo=^SRB_GetDiskInfo;
     SRB_GetDiskInfo=record
	SRB_Cmd:Byte;		       // ASPI command code = SC_EXEC_SCSI_CMD
	SRB_Status:Byte;	       // ASPI command status byte
	SRB_HaId:Byte;		       // ASPI host adapter number
	SRB_Flags:Byte;		       // Reserved
	SRB_Hdr_Rsvd:DWORD;	       // Reserved
	SRB_Target:Byte;	       // Target's SCSI ID
	SRB_Lun:Byte;		       // Target's LUN number
	SRB_DriveFlags:Byte;	       // Driver flags
	SRB_Int13HDriveInfo:Byte;      // Host Adapter Status
	SRB_Heads:Byte;		       // Preferred number of heads translation
	SRB_Sectors:Byte;	       // Preferred number of sectors translation
	SRB_Rsvd1:array[0..9] of Byte; // Reserved
  end;


implementation

end.
